#ifndef __X10_UTIL_ARRAYLIST__IT_H
#define __X10_UTIL_ARRAYLIST__IT_H

#include <x10rt.h>


#define X10_LANG_OBJECT_H_NODEPS
#include <x10/lang/Object.h>
#undef X10_LANG_OBJECT_H_NODEPS
#define X10_UTIL_LISTITERATOR_H_NODEPS
#include <x10/util/ListIterator.h>
#undef X10_UTIL_LISTITERATOR_H_NODEPS
#define X10_LANG_INT_H_NODEPS
#include <x10/lang/Int.h>
#undef X10_LANG_INT_H_NODEPS
namespace x10 { namespace lang { 
class Int;
} } 
namespace x10 { namespace util { 
template<class TPMGL(T)> class ArrayList;
} } 
namespace x10 { namespace lang { 
class Boolean;
} } 
namespace x10 { namespace util { 
template<class TPMGL(T)> class GrowableIndexedMemoryChunk;
} } 
namespace x10 { namespace util { 

template<class TPMGL(S)> class ArrayList__It;
template <> class ArrayList__It<void>;
template<class TPMGL(S)> class ArrayList__It : public x10::lang::Object   {
    public:
    RTT_H_DECLS_CLASS
    
    static x10aux::itable_entry _itables[5];
    
    virtual x10aux::itable_entry* _getITables() { return _itables; }
    
    static typename x10::util::ListIterator<TPMGL(S)>::template itable<x10::util::ArrayList__It<TPMGL(S)> > _itable_0;
    
    static x10::lang::Any::itable<x10::util::ArrayList__It<TPMGL(S)> > _itable_1;
    
    static typename x10::util::CollectionIterator<TPMGL(S)>::template itable<x10::util::ArrayList__It<TPMGL(S)> > _itable_2;
    
    static typename x10::lang::Iterator<TPMGL(S)>::template itable<x10::util::ArrayList__It<TPMGL(S)> > _itable_3;
    
    x10_int FMGL(i);
    
    x10aux::ref<x10::util::ArrayList<TPMGL(S)> > FMGL(al);
    
    void _constructor(x10aux::ref<x10::util::ArrayList<TPMGL(S)> > al);
    
    static x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > _make(x10aux::ref<x10::util::ArrayList<TPMGL(S)> > al);
    
    void _constructor(x10aux::ref<x10::util::ArrayList<TPMGL(S)> > al, x10_int i);
    
    static x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > _make(x10aux::ref<x10::util::ArrayList<TPMGL(S)> > al,
                                                                  x10_int i);
    
    virtual x10_boolean hasNext();
    virtual x10_int nextIndex();
    virtual TPMGL(S) next();
    virtual x10_boolean hasPrevious();
    virtual x10_int previousIndex();
    virtual TPMGL(S) previous();
    virtual void remove();
    virtual void set(TPMGL(S) v);
    virtual void add(TPMGL(S) v);
    virtual x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > x10__util__ArrayList__It____x10__util__ArrayList__It__this(
      );
    void __fieldInitializers46188();
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: virtual x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};
template <> class ArrayList__It<void> : public x10::lang::Object
{
    public:
    static x10aux::RuntimeType rtt;
    static const x10aux::RuntimeType* getRTT() { return & rtt; }
    
};

} } 
#endif // X10_UTIL_ARRAYLIST__IT_H

namespace x10 { namespace util { 
template<class TPMGL(S)> class ArrayList__It;
} } 

#ifndef X10_UTIL_ARRAYLIST__IT_H_NODEPS
#define X10_UTIL_ARRAYLIST__IT_H_NODEPS
#include <x10/lang/Object.h>
#include <x10/util/ListIterator.h>
#include <x10/lang/Int.h>
#include <x10/util/ArrayList.h>
#include <x10/lang/Boolean.h>
#include <x10/util/GrowableIndexedMemoryChunk.h>
#ifndef X10_UTIL_ARRAYLIST__IT_H_GENERICS
#define X10_UTIL_ARRAYLIST__IT_H_GENERICS
#endif // X10_UTIL_ARRAYLIST__IT_H_GENERICS
#ifndef X10_UTIL_ARRAYLIST__IT_H_IMPLEMENTATION
#define X10_UTIL_ARRAYLIST__IT_H_IMPLEMENTATION
#include <x10/util/ArrayList__It.h>

template<class TPMGL(S)> typename x10::util::ListIterator<TPMGL(S)>::template itable<x10::util::ArrayList__It<TPMGL(S)> >  x10::util::ArrayList__It<TPMGL(S)>::_itable_0(&x10::util::ArrayList__It<TPMGL(S)>::add, &x10::util::ArrayList__It<TPMGL(S)>::equals, &x10::util::ArrayList__It<TPMGL(S)>::hasNext, &x10::util::ArrayList__It<TPMGL(S)>::hasPrevious, &x10::util::ArrayList__It<TPMGL(S)>::hashCode, &x10::util::ArrayList__It<TPMGL(S)>::next, &x10::util::ArrayList__It<TPMGL(S)>::nextIndex, &x10::util::ArrayList__It<TPMGL(S)>::previous, &x10::util::ArrayList__It<TPMGL(S)>::previousIndex, &x10::util::ArrayList__It<TPMGL(S)>::remove, &x10::util::ArrayList__It<TPMGL(S)>::set, &x10::util::ArrayList__It<TPMGL(S)>::toString, &x10::util::ArrayList__It<TPMGL(S)>::typeName);
template<class TPMGL(S)> x10::lang::Any::itable<x10::util::ArrayList__It<TPMGL(S)> >  x10::util::ArrayList__It<TPMGL(S)>::_itable_1(&x10::util::ArrayList__It<TPMGL(S)>::equals, &x10::util::ArrayList__It<TPMGL(S)>::hashCode, &x10::util::ArrayList__It<TPMGL(S)>::toString, &x10::util::ArrayList__It<TPMGL(S)>::typeName);
template<class TPMGL(S)> typename x10::util::CollectionIterator<TPMGL(S)>::template itable<x10::util::ArrayList__It<TPMGL(S)> >  x10::util::ArrayList__It<TPMGL(S)>::_itable_2(&x10::util::ArrayList__It<TPMGL(S)>::equals, &x10::util::ArrayList__It<TPMGL(S)>::hasNext, &x10::util::ArrayList__It<TPMGL(S)>::hashCode, &x10::util::ArrayList__It<TPMGL(S)>::next, &x10::util::ArrayList__It<TPMGL(S)>::remove, &x10::util::ArrayList__It<TPMGL(S)>::toString, &x10::util::ArrayList__It<TPMGL(S)>::typeName);
template<class TPMGL(S)> typename x10::lang::Iterator<TPMGL(S)>::template itable<x10::util::ArrayList__It<TPMGL(S)> >  x10::util::ArrayList__It<TPMGL(S)>::_itable_3(&x10::util::ArrayList__It<TPMGL(S)>::equals, &x10::util::ArrayList__It<TPMGL(S)>::hasNext, &x10::util::ArrayList__It<TPMGL(S)>::hashCode, &x10::util::ArrayList__It<TPMGL(S)>::next, &x10::util::ArrayList__It<TPMGL(S)>::toString, &x10::util::ArrayList__It<TPMGL(S)>::typeName);
template<class TPMGL(S)> x10aux::itable_entry x10::util::ArrayList__It<TPMGL(S)>::_itables[5] = {x10aux::itable_entry(&x10aux::getRTT<x10::util::ListIterator<TPMGL(S)> >, &_itable_0), x10aux::itable_entry(&x10aux::getRTT<x10::lang::Any>, &_itable_1), x10aux::itable_entry(&x10aux::getRTT<x10::util::CollectionIterator<TPMGL(S)> >, &_itable_2), x10aux::itable_entry(&x10aux::getRTT<x10::lang::Iterator<TPMGL(S)> >, &_itable_3), x10aux::itable_entry(NULL, (void*)x10aux::getRTT<x10::util::ArrayList__It<TPMGL(S)> >())};

//#line 151 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10FieldDecl_c

//#line 152 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10FieldDecl_c

//#line 154 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10ConstructorDecl_c
template<class TPMGL(S)> void x10::util::ArrayList__It<TPMGL(S)>::_constructor(
                           x10aux::ref<x10::util::ArrayList<TPMGL(S)> > al) {
    
    //#line 155 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10ConstructorCall_c
    (this)->::x10::util::ArrayList__It<TPMGL(S)>::_constructor(al, ((x10_int)-1));
    
}
template<class TPMGL(S)> x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > x10::util::ArrayList__It<TPMGL(S)>::_make(
                           x10aux::ref<x10::util::ArrayList<TPMGL(S)> > al)
{
    x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > this_ = new (memset(x10aux::alloc<x10::util::ArrayList__It<TPMGL(S)> >(), 0, sizeof(x10::util::ArrayList__It<TPMGL(S)>))) x10::util::ArrayList__It<TPMGL(S)>();
    this_->_constructor(al);
    return this_;
}



//#line 158 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10ConstructorDecl_c
template<class TPMGL(S)> void x10::util::ArrayList__It<TPMGL(S)>::_constructor(
                           x10aux::ref<x10::util::ArrayList<TPMGL(S)> > al,
                           x10_int i) {
    
    //#line 158 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10ConstructorCall_c
    (this)->::x10::lang::Object::_constructor();
    
    //#line 158 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.AssignPropertyCall_c
    
    //#line 149 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": Eval of x10.ast.X10Call_c
    ((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->x10::util::ArrayList__It<TPMGL(S)>::__fieldInitializers46188();
    
    //#line 159 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": Eval of x10.ast.X10FieldAssign_c
    ((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->FMGL(al) =
      al;
    
    //#line 160 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": Eval of x10.ast.X10FieldAssign_c
    ((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->FMGL(i) =
      i;
}
template<class TPMGL(S)> x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > x10::util::ArrayList__It<TPMGL(S)>::_make(
                           x10aux::ref<x10::util::ArrayList<TPMGL(S)> > al,
                           x10_int i) {
    x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > this_ = new (memset(x10aux::alloc<x10::util::ArrayList__It<TPMGL(S)> >(), 0, sizeof(x10::util::ArrayList__It<TPMGL(S)>))) x10::util::ArrayList__It<TPMGL(S)>();
    this_->_constructor(al, i);
    return this_;
}



//#line 163 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> x10_boolean x10::util::ArrayList__It<TPMGL(S)>::hasNext(
  ) {
    
    //#line 164 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10Return_c
    return ((((x10_int) ((((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                            FMGL(i)) + (((x10_int)1))))) < (x10aux::nullCheck(((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                                                                                FMGL(al))->size()));
    
}

//#line 167 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> x10_int x10::util::ArrayList__It<TPMGL(S)>::nextIndex(
  ) {
    
    //#line 168 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10Return_c
    return (__extension__ ({
        
        //#line 168 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10LocalDecl_c
        x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > x46559 =
          ((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this);
        
        //#line 168 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": polyglot.ast.Empty_c
        ;
        x10aux::nullCheck(x46559)->FMGL(i) = ((x10_int) ((x10aux::nullCheck(x46559)->
                                                            FMGL(i)) + (((x10_int)1))));
    }))
    ;
    
}

//#line 171 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> TPMGL(S) x10::util::ArrayList__It<TPMGL(S)>::next(
  ) {
    
    //#line 172 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10Return_c
    return x10aux::nullCheck(x10aux::nullCheck(((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                                                 FMGL(al))->
                               FMGL(a))->x10::util::GrowableIndexedMemoryChunk<TPMGL(S)>::__apply(
             (__extension__ ({
                 
                 //#line 172 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10LocalDecl_c
                 x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > x46561 =
                   ((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this);
                 
                 //#line 172 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": polyglot.ast.Empty_c
                 ;
                 x10aux::nullCheck(x46561)->FMGL(i) = ((x10_int) ((x10aux::nullCheck(x46561)->
                                                                     FMGL(i)) + (((x10_int)1))));
             }))
             );
    
}

//#line 175 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> x10_boolean x10::util::ArrayList__It<TPMGL(S)>::hasPrevious(
  ) {
    
    //#line 176 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10Return_c
    return ((((x10_int) ((((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                            FMGL(i)) - (((x10_int)1))))) >= (((x10_int)0)));
    
}

//#line 179 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> x10_int x10::util::ArrayList__It<TPMGL(S)>::previousIndex(
  ) {
    
    //#line 180 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10Return_c
    return (__extension__ ({
        
        //#line 180 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10LocalDecl_c
        x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > x46563 =
          ((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this);
        
        //#line 180 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": polyglot.ast.Empty_c
        ;
        x10aux::nullCheck(x46563)->FMGL(i) = ((x10_int) ((x10aux::nullCheck(x46563)->
                                                            FMGL(i)) - (((x10_int)1))));
    }))
    ;
    
}

//#line 183 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> TPMGL(S) x10::util::ArrayList__It<TPMGL(S)>::previous(
  ) {
    
    //#line 184 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10Return_c
    return x10aux::nullCheck(x10aux::nullCheck(((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                                                 FMGL(al))->
                               FMGL(a))->x10::util::GrowableIndexedMemoryChunk<TPMGL(S)>::__apply(
             (__extension__ ({
                 
                 //#line 184 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10LocalDecl_c
                 x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > x46565 =
                   ((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this);
                 
                 //#line 184 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": polyglot.ast.Empty_c
                 ;
                 x10aux::nullCheck(x46565)->FMGL(i) = ((x10_int) ((x10aux::nullCheck(x46565)->
                                                                     FMGL(i)) - (((x10_int)1))));
             }))
             );
    
}

//#line 187 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> void x10::util::ArrayList__It<TPMGL(S)>::remove(
  ) {
    
    //#line 188 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": Eval of x10.ast.X10Call_c
    x10aux::nullCheck(((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                        FMGL(al))->removeAt(((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                                              FMGL(i));
}

//#line 191 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> void x10::util::ArrayList__It<TPMGL(S)>::set(
  TPMGL(S) v) {
    
    //#line 192 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": Eval of x10.ast.X10Call_c
    x10aux::nullCheck(((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                        FMGL(al))->set(v, ((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                                            FMGL(i));
}

//#line 195 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> void x10::util::ArrayList__It<TPMGL(S)>::add(
  TPMGL(S) v) {
    
    //#line 196 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": Eval of x10.ast.X10Call_c
    x10aux::nullCheck(((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                        FMGL(al))->addBefore(((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
                                               FMGL(i), v);
}

//#line 149 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >
  x10::util::ArrayList__It<TPMGL(S)>::x10__util__ArrayList__It____x10__util__ArrayList__It__this(
  ) {
    
    //#line 149 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10Return_c
    return ((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this);
    
}

//#line 149 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": x10.ast.X10MethodDecl_c
template<class TPMGL(S)> void x10::util::ArrayList__It<TPMGL(S)>::__fieldInitializers46188(
  ) {
    
    //#line 149 "/wrkdirs/usr/ports/lang/x10/work/x10.runtime/src-x10/x10/util/ArrayList.x10": Eval of x10.ast.X10FieldAssign_c
    ((x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> >)this)->
      FMGL(i) = ((x10_int)0);
}
template<class TPMGL(S)> const x10aux::serialization_id_t x10::util::ArrayList__It<TPMGL(S)>::_serialization_id = 
    x10aux::DeserializationDispatcher::addDeserializer(x10::util::ArrayList__It<TPMGL(S)>::_deserializer, x10aux::CLOSURE_KIND_NOT_ASYNC);

template<class TPMGL(S)> void x10::util::ArrayList__It<TPMGL(S)>::_serialize_body(x10aux::serialization_buffer& buf) {
    x10::lang::Object::_serialize_body(buf);
    buf.write(this->FMGL(i));
    buf.write(this->FMGL(al));
    
}

template<class TPMGL(S)> x10aux::ref<x10::lang::Reference> x10::util::ArrayList__It<TPMGL(S)>::_deserializer(x10aux::deserialization_buffer& buf) {
    x10aux::ref<x10::util::ArrayList__It<TPMGL(S)> > this_ = new (memset(x10aux::alloc<x10::util::ArrayList__It<TPMGL(S)> >(), 0, sizeof(x10::util::ArrayList__It<TPMGL(S)>))) x10::util::ArrayList__It<TPMGL(S)>();
    buf.record_reference(this_);
    this_->_deserialize_body(buf);
    return this_;
}

template<class TPMGL(S)> void x10::util::ArrayList__It<TPMGL(S)>::_deserialize_body(x10aux::deserialization_buffer& buf) {
    x10::lang::Object::_deserialize_body(buf);
    FMGL(i) = buf.read<x10_int>();
    FMGL(al) = buf.read<x10aux::ref<x10::util::ArrayList<TPMGL(S)> > >();
}

template<class TPMGL(S)> x10aux::RuntimeType x10::util::ArrayList__It<TPMGL(S)>::rtt;
template<class TPMGL(S)> void x10::util::ArrayList__It<TPMGL(S)>::_initRTT() {
    const x10aux::RuntimeType *canonical = x10aux::getRTT<x10::util::ArrayList__It<void> >();
    if (rtt.initStageOne(canonical)) return;
    const x10aux::RuntimeType* parents[2] = { x10aux::getRTT<x10::lang::Object>(), x10aux::getRTT<x10::util::ListIterator<TPMGL(S)> >()};
    const x10aux::RuntimeType* params[1] = { x10aux::getRTT<TPMGL(S)>()};
    x10aux::RuntimeType::Variance variances[1] = { x10aux::RuntimeType::invariant};
    const char *baseName = "x10.util.ArrayList.It";
    rtt.initStageTwo(baseName, x10aux::RuntimeType::class_kind, 2, parents, 1, params, variances);
}
#endif // X10_UTIL_ARRAYLIST__IT_H_IMPLEMENTATION
#endif // __X10_UTIL_ARRAYLIST__IT_H_NODEPS
